/* grab_it.cpp : Defines the entry point for the application.

 v	10. jan 2006
		uses GetModuleFileName to find, where the exe was launched
		uses the launch path to store dump.bin
		uses GetWindowRect to position the progressbar at bottom of screen
		will dump max 128MB, will exit without use for mem<32MB
 v	12. jan 2006
*/

#define CN30  //this is for a ITC CN30 or CK60 with WM2005
//#undef CN30	  //it is for no use anymore since v 10. jan 2006

//#include "stdafx.h" //not needed as this is a clean win32 api application
#include "windows.h"
// Do we really need the ppc stuff? NOT yet, as SHGetAutoRunPath does not work as exspected
//#include "aygshell.h"
//#pragma comment (lib, "aygshell.lib")
#include "string.h"

//#define targetFile L"\\Mini-SD\\dump.bin"
TCHAR targetFile[MAX_PATH];

int		lineHeight=1;		//progress bar height
int		drawPoint=319;
int		BarPosition=0;
int		screenWidth = GetSystemMetrics(SM_CXSCREEN);
HDC		hdc = ::GetDC(NULL);
HPEN	lineProgress,lineBackground,po;	// Pen Progress bar

wchar_t	Buff[1024];		// buffer for Error messages

DWORD	DumpStart=0x00000000;		//start address
DWORD	DumpSize=0x8000000;			//Size
DWORD	DumpMax=0x8000000;			//Max Size = 128MB
//DWORD DumpMax=0x10000000;			//Max Size = 256MB
DWORD	Step=0x80000;


extern "C" BOOL VirtualCopy( 
  LPVOID lpvDest, 
  LPVOID lpvSrc, 
  DWORD cbSize, 
  DWORD fdwProtect 
);

int ShowProgress(int pos){
	MoveToEx(hdc,0,drawPoint,NULL);

	po = (HPEN)SelectObject(hdc,lineBackground); 
	LineTo(hdc,pos,drawPoint); 

    SelectObject(hdc,lineProgress);
    LineTo(hdc,screenWidth,drawPoint);

	SelectObject(hdc,lineBackground);
    LineTo(hdc,screenWidth,drawPoint);

return 0;
}

int ShowError(wchar_t text[1024]){
	MessageBox(NULL,text,L"ERROR",MB_OK | MB_TOPMOST | MB_SETFOREGROUND);
	return 0;
}

DWORD GetFreeSize(TCHAR Path[MAX_PATH])
{
	//calculate free disk space
	TCHAR storage[MAX_PATH];
	char storageA[MAX_PATH];
	TCHAR strPath[MAX_PATH];
	char strPathA[MAX_PATH];
	wcscpy(strPath, Path);
	uint ix=0;
	char bsl='\\';
	wcstombs(strPathA, strPath, sizeof(strPath)/sizeof(strPath[0]));
	//cut out the volume name out of strPath
	storageA[ix] = strPathA[ix];//copy the first backslash
	ix++;
	do
	{
		if ( (strPathA[ix]!=bsl) && (ix>0) ) //copy all chars
			storageA[ix] = strPathA[ix];
		if ( (strPathA[ix]==bsl) && (ix>0) ) //until second backslash
			break;
		ix++;
	}while (ix < strlen(strPathA));
	mbstowcs(storage, storageA, sizeof(storageA));

    ULARGE_INTEGER lnCallerFree, lnTotal, lnFree;
	GetDiskFreeSpaceEx (storage, &lnCallerFree, &lnTotal, &lnFree);
	
	//we only return the low part, actually no device supports more than 128MB ROM
	DWORD FreeMB = (DWORD)(lnCallerFree.LowPart / 0x100000) * 0x100000;
	if (FreeMB > DumpMax)
		FreeMB = DumpMax;
	return FreeMB; //return only full MBs
}

void calcDrawPoint()
{
	RECT r;
	HWND hWnd;
	hWnd=FindWindow(L"DesktopExplorerWindow", NULL);//L"Desktop Window");
	if (hWnd != NULL)
	{
		GetWindowRect(hWnd, &r);
		drawPoint=r.bottom-1;
	}
}

int WINAPI WinMain(	HINSTANCE hInstance,
					HINSTANCE hPrevInstance,
					LPTSTR    lpCmdLine,
					int       nCmdShow)
{/// 1st
	
	//drawPoint
	calcDrawPoint();

	lineProgress = CreatePen(PS_SOLID,lineHeight,RGB(255,0,0)); // Progress bar
	lineBackground = CreatePen(PS_SOLID,lineHeight,RGB(100,100,100)); // Background bar

	//SHGetAutoRunPath did not work as needed, especially during debugging
	//BOOL SHGetAutoRunPath (LPTSTR pAutoRunPath);
	//TCHAR pAutoRunPath[MAX_PATH];
	//TCHAR szTmp[MAX_PATH];

	TCHAR strPath[MAX_PATH];
	GetModuleFileName (NULL, strPath, MAX_PATH);

	//	SHGetAutoRunPath (pAutoRunPath); //will return something like \Storage Card 1\2577\autorun.exe

	//find the last backslash
	TCHAR* p;
	if ( p = wcsrchr ( strPath, '\\')) 
		*++p = _T('\0'); // zero-terminate at the last backslash

#ifdef CN30
	wsprintf(targetFile, L"\\SD Card\\dump.bin");
#else
	wsprintf(targetFile, L"%sdump.bin",strPath);
#endif
	DumpSize = GetFreeSize(strPath);

	if (DumpSize < 0x2000000)
	{
		MessageBeep(MB_ICONEXCLAMATION);
		return 2;  //Free mem is lower than 32MB!
	}

	HANDLE H=CreateFile(targetFile,GENERIC_WRITE,0,0,CREATE_ALWAYS,FILE_FLAG_WRITE_THROUGH,0);
	if(H==INVALID_HANDLE_VALUE)
	{
		MessageBox(NULL,targetFile,L"Error",MB_OK);
		return 1;
	}

	//for( i; i<DumpSize*1024*1024; i+=512*1024)
	for(DWORD i=DumpStart; i<(DumpStart+DumpSize); i+=Step)
	{
		LPVOID Ptr=VirtualAlloc(
			0, 
			512*1024,
			MEM_RESERVE,
			PAGE_READONLY
			); 
		if(Ptr==0)
		{
			wsprintf(Buff,L"Cannot allocate %08X",i);
			ShowError(Buff);
			return 1;
		}
		/// update progress bar ///
		BarPosition=((i-DumpStart)/(DumpSize/screenWidth));
		ShowProgress(BarPosition);
		///////////////////////////

		if(!VirtualCopy(Ptr,(void*)(i/256),512*1024,PAGE_EXECUTE_READWRITE|PAGE_PHYSICAL))
		{
			wsprintf(Buff,L"Cannot map %08X",i);
			ShowError(Buff);
			return 1;
		}
		DWORD W=0;
		WriteFile(H,Ptr,512*1024,&W,0);
		if(W!=512*1024)
		{
			wsprintf(Buff,L"Error on WriteFile. Card full?",i);
			ShowError(Buff);
			CloseHandle(H);
			return 1;
		}
		VirtualFree(Ptr,0,MEM_RELEASE);
	}

	CloseHandle(H);

	MessageBeep(MB_OK);

	DeleteObject(lineBackground);
	DeleteObject(lineProgress);
	return 0;
}
